> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/xamarin/guides/android/manipulation/create-pages.md).

# Create pages (Android)

Learn how to create and add new document pages in Android using Xamarin.Android UI components. Customize page types, sizes, and colors with the AddPageDialogFragment. Start creating your PDF documents

You can create pages using the add pages dialog or programmatically with Xamarin.Android

{% tabs %}
{% tab title="UI component" %}

## Add or create new document pages in Android

{% hint style="info" %}
**This tutorial only applies to Xamarin.Android.**
{% endhint %}

The [`AddPageDialogFragment`](https://sdk.apryse.com/api/xamarinandroid/tools/api/pdftron.PDF.Controls.AddPageDialogFragment.html) allows users are able to add new pages to an existing document or create a completely new document. The new pages created can have various types, sizes, and colors.

![](https://653871032-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FgjsBtuYmcKhWOdM9VCg4%2Fuploads%2Fgit-blob-de25653365e8f896fae4fd5a9d3d3a9465ad9f1a%2F8388d04f51e54f679e6e2075355c3bea138e8a1a-2300x2300.png?alt=media)

Add page dialog: dialog for creating new document (left), dialog for adding pages to an existing document (right).

## Page properties

The following properties are available for creating or adding pages:

* `PageType` The following types of page are supported in this dialog:
  * `Blank`: a page with nothing on it.
  * `Lined`: a page with horizontal lines on it.
  * `Grid`: a page with a superimposed grid on it.
  * `Graph`: a page with Cartesian axes on it.
  * `Music`: a page set up with modern staff notation for notating music.
* `PageSize` The following page sizes are supported in this dialog: `Custom`, `Letter`, `Legal`, `A4`, `A3`, `Ledger`.

{% hint style="info" %}
The `Custom` option is only available when adding new pages to an existing PDF document, not when a new document is being created. The page size of `Custom` option is specified as here: [add pages to an existing document](https://docs.apryse.com)
{% endhint %}

* `PageColor` The page background can be set to the following colors: `White`, `Yellow`, and `Blueprint`.

## Create a new PDF document

To create a new PDF document, call `newInstance()` and override the `OnCreateNewDocumentListener` interface. The implementation of `onCreateNewDocument(PDFDoc, String)` should create a new file with the given title normalized to a ".pdf" extension.

{% code lineNumbers="true" %}

```csharp
var addPageDialogFragment = AddPageDialogFragment.NewInstance();
addPageDialogFragment.CreateNewDocument += (sender, e) =>
{
    if (e.PdfDoc == null || e.Title == null)
    {
        return;
    }
    var title = e.Title;
    if (!title.EndsWith(".pdf", true, null))
    {
        title = title + ".pdf";
    }
    Java.IO.File folder = Android.OS.Environment.GetExternalStoragePublicDirectory(Android.OS.Environment.DirectoryDownloads);
    Java.IO.File documentFile = new Java.IO.File(folder, title);
    try
    {
        e.PdfDoc.Save(documentFile.AbsolutePath, (long)pdftron.SDF.SDFDoc.SaveOptions.e_remove_unused, null);
        Console.WriteLine("New file saved: " + documentFile.AbsolutePath);
    }
    catch (Exception ex)
    {
        Console.WriteLine(ex.Message);
    }
    finally
    {
        e.PdfDoc.Close();
    }

};
addPageDialogFragment.Show(this.SupportFragmentManager, "add_page_dialog");
```

{% endcode %}

## Add pages to an existing document

To add pages to an existing PDF, create a new instance of the add page dialog fragment using `newInstance(double, double)` and provide the valid page width and page height arguments. These arguments will be used only if the user selects the `Custom` option in the Page Size dropdown. You also must implement the `OnAddNewPagesListener` interface and override `onAddNewPages(Page[])`, in which the implementation should add the provided pages to the document.

{% code lineNumbers="true" %}

```csharp
var addPageDialogFragment = AddPageDialogFragment.NewInstance(myPageWidth, myPageHeight);
addPageDialogFragment.AddNewPages += (sender, e) =>
{
    if (mPdfDoc == null || mPdfViewCtrl == null)
    {
        return;
    }
    bool shouldUnlock = false;
    try
    {
        mPdfViewCtrl.DocLock(true);
        shouldUnlock = true;

        for (int i = 1, cnt = e.Pages.Length; i <= cnt; i++)
        {
            int newPageNum = mPdfViewCtrl.CurrentPage + i;
            var pageNative = e.Pages[i - 1];
            var page = TypeConvertHelper.ConvPageToManaged(pageNative);
            mPdfDoc.PageInsert(mPdfDoc.GetPageIterator(newPageNum), page);
        }
    }
    catch (PDFNetException ex)
    {
        Console.WriteLine(ex.GetMessage());
    }
    finally
    {
        if (shouldUnlock)
        {
            mPdfViewCtrl.DocUnlock();
        }
    }
    mPdfViewCtrl.UpdatePageLayout();
    mPdfViewCtrl.CurrentPage = mPdfViewCtrl.CurrentPage + 1;
    if (mSeekBar != null)
    {
        mSeekBar.SetProgress(mPdfViewCtrl.CurrentPage);
    }
};
addPageDialogFragment.Show(this.SupportFragmentManager, "add_page_dialog");
```

{% endcode %}
{% endtab %}

{% tab title="API guide" %}

## API to programmatically create pages in Android

To create a new 8.5x11 blank page and add it at the end of document's page sequence.

Note that, after the page is created, it does not yet belong to a document's page sequence. The page needs to be placed within the page sequence in order to become "visible". `PagePushBack()` inserts page x into the position of the document's last page.

{% code lineNumbers="true" %}

```csharp
PDFDoc doc = new PDFDoc();

// create a new page
Page x = doc.PageCreate();
doc.PagePushBack(x);
```

{% endcode %}

## About creating a new blank page

To create a new page, use the `PDFDoc.PageCreate(media_box)` method. `PageCreate()` takes an optional Rect argument that can be used to specify page size. This Rect is called a media box.

A media box is a rectangle, expressed in default user space units, defining the boundaries of the physical medium on which the page is intended to be displayed or printed. A user space unit is 1/72 of an inch. If media\_box is unspecified, the default dimensions of the page are 8.5 x 11 inches (or 8.5\*72, 11\*72 units).
{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.apryse.com/xamarin/guides/android/manipulation/create-pages.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
